import { jsx as a, Fragment as ge } from "react/jsx-runtime";
import * as l from "react";
import C, { useContext as me } from "react";
import G from "clsx";
/*!
  @versini/ui-togglegroup v1.4.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TOGGLEGROUP__ || (window.__VERSINI_UI_TOGGLEGROUP__ = {
    version: "1.4.0",
    buildTime: "12/25/2024 12:30 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ve = "av-togglegroup", Ce = "av-togglegroup-item-wrapper", he = "av-togglegroup-item";
function U(e, t = []) {
  let o = [];
  function r(s, c) {
    const u = l.createContext(c), i = o.length;
    o = [...o, c];
    const f = (p) => {
      var g;
      const { scope: h, children: I, ...d } = p, m = ((g = h == null ? void 0 : h[e]) == null ? void 0 : g[i]) || u, _ = l.useMemo(() => d, Object.values(d));
      return /* @__PURE__ */ a(m.Provider, { value: _, children: I });
    };
    f.displayName = s + "Provider";
    function v(p, h) {
      var m;
      const I = ((m = h == null ? void 0 : h[e]) == null ? void 0 : m[i]) || u, d = l.useContext(I);
      if (d) return d;
      if (c !== void 0) return c;
      throw new Error(`\`${p}\` must be used within \`${s}\``);
    }
    return [f, v];
  }
  const n = () => {
    const s = o.map((c) => l.createContext(c));
    return function(u) {
      const i = (u == null ? void 0 : u[e]) || s;
      return l.useMemo(
        () => ({ [`__scope${e}`]: { ...u, [e]: i } }),
        [u, i]
      );
    };
  };
  return n.scopeName = e, [r, be(n, ...t)];
}
function be(...e) {
  const t = e[0];
  if (e.length === 1) return t;
  const o = () => {
    const r = e.map((n) => ({
      useScope: n(),
      scopeName: n.scopeName
    }));
    return function(s) {
      const c = r.reduce((u, { useScope: i, scopeName: f }) => {
        const p = i(s)[`__scope${f}`];
        return { ...u, ...p };
      }, {});
      return l.useMemo(() => ({ [`__scope${t.scopeName}`]: c }), [c]);
    };
  };
  return o.scopeName = t.scopeName, o;
}
function W(e, t) {
  if (typeof e == "function")
    return e(t);
  e != null && (e.current = t);
}
function z(...e) {
  return (t) => {
    let o = !1;
    const r = e.map((n) => {
      const s = W(n, t);
      return !o && typeof s == "function" && (o = !0), s;
    });
    if (o)
      return () => {
        for (let n = 0; n < r.length; n++) {
          const s = r[n];
          typeof s == "function" ? s() : W(e[n], null);
        }
      };
  };
}
function D(...e) {
  return l.useCallback(z(...e), e);
}
var A = l.forwardRef((e, t) => {
  const { children: o, ...r } = e, n = l.Children.toArray(o), s = n.find(_e);
  if (s) {
    const c = s.props.children, u = n.map((i) => i === s ? l.Children.count(c) > 1 ? l.Children.only(null) : l.isValidElement(c) ? c.props.children : null : i);
    return /* @__PURE__ */ a(L, { ...r, ref: t, children: l.isValidElement(c) ? l.cloneElement(c, void 0, u) : null });
  }
  return /* @__PURE__ */ a(L, { ...r, ref: t, children: o });
});
A.displayName = "Slot";
var L = l.forwardRef((e, t) => {
  const { children: o, ...r } = e;
  if (l.isValidElement(o)) {
    const n = Re(o);
    return l.cloneElement(o, {
      ...Te(r, o.props),
      // @ts-ignore
      ref: t ? z(t, n) : n
    });
  }
  return l.Children.count(o) > 1 ? l.Children.only(null) : null;
});
L.displayName = "SlotClone";
var Ie = ({ children: e }) => /* @__PURE__ */ a(ge, { children: e });
function _e(e) {
  return l.isValidElement(e) && e.type === Ie;
}
function Te(e, t) {
  const o = { ...t };
  for (const r in t) {
    const n = e[r], s = t[r];
    /^on[A-Z]/.test(r) ? n && s ? o[r] = (...u) => {
      s(...u), n(...u);
    } : n && (o[r] = n) : r === "style" ? o[r] = { ...n, ...s } : r === "className" && (o[r] = [n, s].filter(Boolean).join(" "));
  }
  return { ...e, ...o };
}
function Re(e) {
  var r, n;
  let t = (r = Object.getOwnPropertyDescriptor(e.props, "ref")) == null ? void 0 : r.get, o = t && "isReactWarning" in t && t.isReactWarning;
  return o ? e.ref : (t = (n = Object.getOwnPropertyDescriptor(e, "ref")) == null ? void 0 : n.get, o = t && "isReactWarning" in t && t.isReactWarning, o ? e.props.ref : e.props.ref || e.ref);
}
var ye = [
  "a",
  "button",
  "div",
  "form",
  "h2",
  "h3",
  "img",
  "input",
  "label",
  "li",
  "nav",
  "ol",
  "p",
  "span",
  "svg",
  "ul"
], w = ye.reduce((e, t) => {
  const o = l.forwardRef((r, n) => {
    const { asChild: s, ...c } = r, u = s ? A : t;
    return typeof window < "u" && (window[Symbol.for("radix-ui")] = !0), /* @__PURE__ */ a(u, { ...c, ref: n });
  });
  return o.displayName = `Primitive.${t}`, { ...e, [t]: o };
}, {});
function y(e, t, { checkForDefaultPrevented: o = !0 } = {}) {
  return function(n) {
    if (e == null || e(n), o === !1 || !n.defaultPrevented)
      return t == null ? void 0 : t(n);
  };
}
function Se(e) {
  const t = e + "CollectionProvider", [o, r] = U(t), [n, s] = o(
    t,
    { collectionRef: { current: null }, itemMap: /* @__PURE__ */ new Map() }
  ), c = (I) => {
    const { scope: d, children: m } = I, _ = C.useRef(null), g = C.useRef(/* @__PURE__ */ new Map()).current;
    return /* @__PURE__ */ a(n, { scope: d, itemMap: g, collectionRef: _, children: m });
  };
  c.displayName = t;
  const u = e + "CollectionSlot", i = C.forwardRef(
    (I, d) => {
      const { scope: m, children: _ } = I, g = s(u, m), b = D(d, g.collectionRef);
      return /* @__PURE__ */ a(A, { ref: b, children: _ });
    }
  );
  i.displayName = u;
  const f = e + "CollectionItemSlot", v = "data-radix-collection-item", p = C.forwardRef(
    (I, d) => {
      const { scope: m, children: _, ...g } = I, b = C.useRef(null), S = D(d, b), P = s(f, m);
      return C.useEffect(() => (P.itemMap.set(b, { ref: b, ...g }), () => void P.itemMap.delete(b))), /* @__PURE__ */ a(A, { [v]: "", ref: S, children: _ });
    }
  );
  p.displayName = f;
  function h(I) {
    const d = s(e + "CollectionConsumer", I);
    return C.useCallback(() => {
      const _ = d.collectionRef.current;
      if (!_) return [];
      const g = Array.from(_.querySelectorAll(`[${v}]`));
      return Array.from(d.itemMap.values()).sort(
        (P, x) => g.indexOf(P.ref.current) - g.indexOf(x.ref.current)
      );
    }, [d.collectionRef, d.itemMap]);
  }
  return [
    { Provider: c, Slot: i, ItemSlot: p },
    h,
    r
  ];
}
var Pe = globalThis != null && globalThis.document ? l.useLayoutEffect : () => {
}, Ge = l.useId || (() => {
}), Ee = 0;
function xe(e) {
  const [t, o] = l.useState(Ge());
  return Pe(() => {
    o((r) => r ?? String(Ee++));
  }, [e]), t ? `radix-${t}` : "";
}
function $(e) {
  const t = l.useRef(e);
  return l.useEffect(() => {
    t.current = e;
  }), l.useMemo(() => (...o) => {
    var r;
    return (r = t.current) == null ? void 0 : r.call(t, ...o);
  }, []);
}
function F({
  prop: e,
  defaultProp: t,
  onChange: o = () => {
  }
}) {
  const [r, n] = we({ defaultProp: t, onChange: o }), s = e !== void 0, c = s ? e : r, u = $(o), i = l.useCallback(
    (f) => {
      if (s) {
        const p = typeof f == "function" ? f(e) : f;
        p !== e && u(p);
      } else
        n(f);
    },
    [s, e, n, u]
  );
  return [c, i];
}
function we({
  defaultProp: e,
  onChange: t
}) {
  const o = l.useState(e), [r] = o, n = l.useRef(r), s = $(t);
  return l.useEffect(() => {
    n.current !== r && (s(r), n.current = r);
  }, [r, n, s]), o;
}
var Ae = l.createContext(void 0);
function q(e) {
  const t = l.useContext(Ae);
  return e || t || "ltr";
}
var O = "rovingFocusGroup.onEntryFocus", Ne = { bubbles: !1, cancelable: !0 }, k = "RovingFocusGroup", [V, Z, Fe] = Se(k), [ke, J] = U(
  k,
  [Fe]
), [Me, Oe] = ke(k), Q = l.forwardRef(
  (e, t) => /* @__PURE__ */ a(V.Provider, { scope: e.__scopeRovingFocusGroup, children: /* @__PURE__ */ a(V.Slot, { scope: e.__scopeRovingFocusGroup, children: /* @__PURE__ */ a(De, { ...e, ref: t }) }) })
);
Q.displayName = k;
var De = l.forwardRef((e, t) => {
  const {
    __scopeRovingFocusGroup: o,
    orientation: r,
    loop: n = !1,
    dir: s,
    currentTabStopId: c,
    defaultCurrentTabStopId: u,
    onCurrentTabStopIdChange: i,
    onEntryFocus: f,
    preventScrollOnEntryFocus: v = !1,
    ...p
  } = e, h = l.useRef(null), I = D(t, h), d = q(s), [m = null, _] = F({
    prop: c,
    defaultProp: u,
    onChange: i
  }), [g, b] = l.useState(!1), S = $(f), P = Z(o), x = l.useRef(!1), [ae, K] = l.useState(0);
  return l.useEffect(() => {
    const T = h.current;
    if (T)
      return T.addEventListener(O, S), () => T.removeEventListener(O, S);
  }, [S]), /* @__PURE__ */ a(
    Me,
    {
      scope: o,
      orientation: r,
      dir: d,
      loop: n,
      currentTabStopId: m,
      onItemFocus: l.useCallback(
        (T) => _(T),
        [_]
      ),
      onItemShiftTab: l.useCallback(() => b(!0), []),
      onFocusableItemAdd: l.useCallback(
        () => K((T) => T + 1),
        []
      ),
      onFocusableItemRemove: l.useCallback(
        () => K((T) => T - 1),
        []
      ),
      children: /* @__PURE__ */ a(
        w.div,
        {
          tabIndex: g || ae === 0 ? -1 : 0,
          "data-orientation": r,
          ...p,
          ref: I,
          style: { outline: "none", ...e.style },
          onMouseDown: y(e.onMouseDown, () => {
            x.current = !0;
          }),
          onFocus: y(e.onFocus, (T) => {
            const ie = !x.current;
            if (T.target === T.currentTarget && ie && !g) {
              const j = new CustomEvent(O, Ne);
              if (T.currentTarget.dispatchEvent(j), !j.defaultPrevented) {
                const M = P().filter((R) => R.focusable), de = M.find((R) => R.active), fe = M.find((R) => R.id === m), pe = [de, fe, ...M].filter(
                  Boolean
                ).map((R) => R.ref.current);
                ee(pe, v);
              }
            }
            x.current = !1;
          }),
          onBlur: y(e.onBlur, () => b(!1))
        }
      )
    }
  );
}), X = "RovingFocusGroupItem", H = l.forwardRef(
  (e, t) => {
    const {
      __scopeRovingFocusGroup: o,
      focusable: r = !0,
      active: n = !1,
      tabStopId: s,
      ...c
    } = e, u = xe(), i = s || u, f = Oe(X, o), v = f.currentTabStopId === i, p = Z(o), { onFocusableItemAdd: h, onFocusableItemRemove: I } = f;
    return l.useEffect(() => {
      if (r)
        return h(), () => I();
    }, [r, h, I]), /* @__PURE__ */ a(
      V.ItemSlot,
      {
        scope: o,
        id: i,
        focusable: r,
        active: n,
        children: /* @__PURE__ */ a(
          w.span,
          {
            tabIndex: v ? 0 : -1,
            "data-orientation": f.orientation,
            ...c,
            ref: t,
            onMouseDown: y(e.onMouseDown, (d) => {
              r ? f.onItemFocus(i) : d.preventDefault();
            }),
            onFocus: y(e.onFocus, () => f.onItemFocus(i)),
            onKeyDown: y(e.onKeyDown, (d) => {
              if (d.key === "Tab" && d.shiftKey) {
                f.onItemShiftTab();
                return;
              }
              if (d.target !== d.currentTarget) return;
              const m = Ue(d, f.orientation, f.dir);
              if (m !== void 0) {
                if (d.metaKey || d.ctrlKey || d.altKey || d.shiftKey) return;
                d.preventDefault();
                let g = p().filter((b) => b.focusable).map((b) => b.ref.current);
                if (m === "last") g.reverse();
                else if (m === "prev" || m === "next") {
                  m === "prev" && g.reverse();
                  const b = g.indexOf(d.currentTarget);
                  g = f.loop ? $e(g, b + 1) : g.slice(b + 1);
                }
                setTimeout(() => ee(g));
              }
            })
          }
        )
      }
    );
  }
);
H.displayName = X;
var Le = {
  ArrowLeft: "prev",
  ArrowUp: "prev",
  ArrowRight: "next",
  ArrowDown: "next",
  PageUp: "first",
  Home: "first",
  PageDown: "last",
  End: "last"
};
function Ve(e, t) {
  return t !== "rtl" ? e : e === "ArrowLeft" ? "ArrowRight" : e === "ArrowRight" ? "ArrowLeft" : e;
}
function Ue(e, t, o) {
  const r = Ve(e.key, o);
  if (!(t === "vertical" && ["ArrowLeft", "ArrowRight"].includes(r)) && !(t === "horizontal" && ["ArrowUp", "ArrowDown"].includes(r)))
    return Le[r];
}
function ee(e, t = !1) {
  const o = document.activeElement;
  for (const r of e)
    if (r === o || (r.focus({ preventScroll: t }), document.activeElement !== o)) return;
}
function $e(e, t) {
  return e.map((o, r) => e[(t + r) % e.length]);
}
var Be = Q, Ke = H, je = "Toggle", te = l.forwardRef((e, t) => {
  const { pressed: o, defaultPressed: r = !1, onPressedChange: n, ...s } = e, [c = !1, u] = F({
    prop: o,
    onChange: n,
    defaultProp: r
  });
  return /* @__PURE__ */ a(
    w.button,
    {
      type: "button",
      "aria-pressed": c,
      "data-state": c ? "on" : "off",
      "data-disabled": e.disabled ? "" : void 0,
      ...s,
      ref: t,
      onClick: y(e.onClick, () => {
        e.disabled || u(!c);
      })
    }
  );
});
te.displayName = je;
var E = "ToggleGroup", [oe, lt] = U(E, [
  J
]), re = J(), B = C.forwardRef((e, t) => {
  const { type: o, ...r } = e;
  if (o === "single")
    return /* @__PURE__ */ a(We, { ...r, ref: t });
  if (o === "multiple")
    return /* @__PURE__ */ a(Ye, { ...r, ref: t });
  throw new Error(`Missing prop \`type\` expected on \`${E}\``);
});
B.displayName = E;
var [ne, se] = oe(E), We = C.forwardRef((e, t) => {
  const {
    value: o,
    defaultValue: r,
    onValueChange: n = () => {
    },
    ...s
  } = e, [c, u] = F({
    prop: o,
    defaultProp: r,
    onChange: n
  });
  return /* @__PURE__ */ a(
    ne,
    {
      scope: e.__scopeToggleGroup,
      type: "single",
      value: c ? [c] : [],
      onItemActivate: u,
      onItemDeactivate: C.useCallback(() => u(""), [u]),
      children: /* @__PURE__ */ a(ce, { ...s, ref: t })
    }
  );
}), Ye = C.forwardRef((e, t) => {
  const {
    value: o,
    defaultValue: r,
    onValueChange: n = () => {
    },
    ...s
  } = e, [c = [], u] = F({
    prop: o,
    defaultProp: r,
    onChange: n
  }), i = C.useCallback(
    (v) => u((p = []) => [...p, v]),
    [u]
  ), f = C.useCallback(
    (v) => u((p = []) => p.filter((h) => h !== v)),
    [u]
  );
  return /* @__PURE__ */ a(
    ne,
    {
      scope: e.__scopeToggleGroup,
      type: "multiple",
      value: c,
      onItemActivate: i,
      onItemDeactivate: f,
      children: /* @__PURE__ */ a(ce, { ...s, ref: t })
    }
  );
});
B.displayName = E;
var [ze, qe] = oe(E), ce = C.forwardRef(
  (e, t) => {
    const {
      __scopeToggleGroup: o,
      disabled: r = !1,
      rovingFocus: n = !0,
      orientation: s,
      dir: c,
      loop: u = !0,
      ...i
    } = e, f = re(o), v = q(c), p = { role: "group", dir: v, ...i };
    return /* @__PURE__ */ a(ze, { scope: o, rovingFocus: n, disabled: r, children: n ? /* @__PURE__ */ a(
      Be,
      {
        asChild: !0,
        ...f,
        orientation: s,
        dir: v,
        loop: u,
        children: /* @__PURE__ */ a(w.div, { ...p, ref: t })
      }
    ) : /* @__PURE__ */ a(w.div, { ...p, ref: t }) });
  }
), N = "ToggleGroupItem", ue = C.forwardRef(
  (e, t) => {
    const o = se(N, e.__scopeToggleGroup), r = qe(N, e.__scopeToggleGroup), n = re(e.__scopeToggleGroup), s = o.value.includes(e.value), c = r.disabled || e.disabled, u = { ...e, pressed: s, disabled: c }, i = C.useRef(null);
    return r.rovingFocus ? /* @__PURE__ */ a(
      Ke,
      {
        asChild: !0,
        ...n,
        focusable: !c,
        active: s,
        ref: i,
        children: /* @__PURE__ */ a(Y, { ...u, ref: t })
      }
    ) : /* @__PURE__ */ a(Y, { ...u, ref: t });
  }
);
ue.displayName = N;
var Y = C.forwardRef(
  (e, t) => {
    const { __scopeToggleGroup: o, value: r, ...n } = e, s = se(N, o), c = { role: "radio", "aria-checked": e.pressed, "aria-pressed": void 0 }, u = s.type === "single" ? c : void 0;
    return /* @__PURE__ */ a(
      te,
      {
        ...u,
        ...n,
        ref: t,
        onPressedChange: (i) => {
          i ? s.onItemActivate(r) : s.onItemDeactivate(r);
        }
      }
    );
  }
), Ze = B, Je = ue;
const le = C.createContext({
  size: "medium",
  focusMode: "system",
  mode: "system"
});
/*!
  @versini/ui-spacing v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.0.0",
    buildTime: "12/25/2024 12:30 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Qe = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const o = [];
    (e == null ? void 0 : e.t) !== void 0 && o.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && o.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && o.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && o.push(`ml-${e.l}`), t = o.join(" ");
  }
  return t;
}, Xe = ({ focusMode: e }) => G("focus:outline", "focus:outline-2", "focus:outline-offset", {
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), He = ({ mode: e }) => G({
  "data-[state=on]:bg-surface-medium": e === "dark",
  "data-[state=on]:bg-surface-lightest": e === "light",
  "data-[state=on]:bg-surface-lightest dark:data-[state=on]:bg-surface-medium": e === "system",
  "data-[state=on]:bg-surface-medium dark:data-[state=on]:bg-surface-lightest": e === "alt-system"
}), et = ({ size: e }) => G({
  "h-5 px-2": e === "small",
  "h-6 px-3": e === "medium",
  "h-7 px-4": e === "large"
}), tt = ({ mode: e }) => G(
  Ce,
  "px-1",
  "relative",
  "border-r",
  "last:border-transparent",
  "has-[button[aria-checked='true']]:border-transparent",
  "has-[+_*_button[aria-checked='false']]:border-border-medium",
  {
    "border-surface-light": e === "light",
    "border-surface-darker": e === "dark",
    "border-surface-light dark:border-surface-darker": e === "system",
    "border-surface-darker dark:border-surface-light": e === "alt-system"
  }
), ot = ({
  focusMode: e,
  mode: t,
  size: o
}) => ({
  wrapperClass: tt({ mode: t }),
  itemClass: G(
    he,
    "flex items-center justify-center bg-transparent",
    "rounded-sm",
    "transition duration-200 ease",
    et({ size: o }),
    Xe({ focusMode: e }),
    He({ mode: t })
  )
}), rt = ({
  mode: e,
  spacing: t
}) => G(
  ve,
  Qe(t),
  "inline-flex p-1",
  "rounded-sm",
  {
    "bg-surface-light text-copy-dark": e === "light",
    "bg-surface-darker text-copy-lighter": e === "dark",
    "bg-surface-light text-copy-dark dark:bg-surface-darker dark:text-copy-lighter": e === "system",
    "bg-surface-darker text-copy-lighter dark:bg-surface-light dark:text-copy-dark": e === "alt-system"
  }
), at = ({
  children: e,
  value: t,
  onValueChange: o,
  disabled: r,
  mode: n = "system",
  focusMode: s = "system",
  size: c = "medium",
  defaultValue: u,
  spacing: i,
  ...f
}) => {
  const v = rt({ mode: n, spacing: i }), p = { size: c, focusMode: s, mode: n };
  return /* @__PURE__ */ a(le.Provider, { value: p, children: /* @__PURE__ */ a(
    Ze,
    {
      disabled: r,
      className: v,
      value: t,
      defaultValue: u,
      onValueChange: o,
      ...f,
      type: "single",
      children: e
    }
  ) });
}, it = ({ value: e, disabled: t }) => {
  const { size: o, focusMode: r, mode: n } = me(le), { itemClass: s, wrapperClass: c } = ot({
    focusMode: r,
    mode: n,
    size: o
  });
  return /* @__PURE__ */ a("div", { className: c, children: /* @__PURE__ */ a(
    Je,
    {
      disabled: t,
      className: s,
      value: e,
      children: e
    }
  ) });
};
export {
  ve as TOGGLEGROUP_CLASSNAME,
  he as TOGGLEGROUP_ITEM_CLASSNAME,
  Ce as TOGGLEGROUP_ITEM_WRAPPER_CLASSNAME,
  at as ToggleGroup,
  it as ToggleGroupItem
};
